
from MQTT import Topic
from typing import Any, Callable



# TODO: dev is stalled!
#       at first, we'll design easier things to not loose focus on the project
#       Just use simple properties and triggers to get the same (write-only) behavior
#
# TODO ^2: use functools.wraps to copy the annotations of decorated functions
class MQTTProperty:

  def __init__(self, name: str = None, initialValue: Any = None, getConvert: Callable[[str], Any] = None, setConvert: Callable[[Any], str] = None, readOnly = False):

    self.__ro = readOnly
    self.__value = initialValue

    self.__mqtt = None

    if getConvert is not None:
      self.__name = getConvert.__name__
      self.__getConvert = getConvert
    else:
      self.__getConvert = lambda x: x

    if setConvert is not None:
      self.__setConvert = setConvert
    else:
      self.__setConvert = lambda x: x

    if name is not None:
      self.__name = name


  def __call__(self, getConvert: Callable[[str], Any]):
    self.__getConvert = getConvert

    if self.__name is not None:
      self.__name = getConvert.__name__

  def __get__(self, obj, cls):
    if self.__value is not None:
      return self.__value
    else:
      raise AttributeError('not in sync')

  def __set__(self, obj, value):
    if self.__ro: raise AttributeError(f'MQTTProperty[ {self.__name} ] is read-only')

    # TODO: publish value!

  def __del__(*ignored):
    raise AttributeError('deletion not supported')




class MQTTTrigger:

  # TODO: should we check message's type instead to decide if it is binary? evaluate!
  def __init__(self, topic: str = None, message: str = None, binaryMessage: bytes = None):

    if topic is not None:
      self.__topic = Topic(topic)
    else:
      raise AttributeError('topic is mandatory')  # TODO: correct exception…?

    if binaryMessage is not None:
      self.__message = binaryMessage
    elif message is not None:
      self.__message = bytes(message, 'UTF-8')
    else:
      self.__message = b''

  # ###################
  # ###  TODO: !!!  ###
  # ###################
  def __call__(self, func) -> Callable[[Any], Any]:
    self.__function = func
    return self


class Device:

  def __init__(self, torch, name: str, online: bool = True):
    self._torch = torch
    self.__name = name
    self.__online = online

  @property
  def name(self):
    return self.__name

  @property
  def online(self):
    return self.__online

  @MQTTTrigger(topic='{NameSpace}/{DeviceName}/command', message='restart')
  def restart(self): pass


class Extension:

  def __init__(self, device: Device):
    setattr(device, type(self).__name__, self)


class ExtensionManager:

  def __init__(self):
    pass

